__copyright__ = "Copyright 2021, 3Liz"
__license__ = "GPL version 3"
__email__ = "info@3liz.org"


from qgis.core import QgsApplication
from qgis.PyQt.QtCore import QSettings, QUrl
from qgis.PyQt.QtGui import QDesktopServices, QIcon
from qgis.PyQt.QtWidgets import QAction
from qgis.utils import iface
import qgis


# include <QSettings>
import os
from .about_form import AboutDialog
from .tools.resources import (
    # plugin_path,
    pyperclip,
    resources_path,
    maj_verif,
)
pyperclip()

try:
    from .copie_editor import Copie_Editor
except NameError:
    print('404')


class PgCopie:
    def __init__(self):
        """ Constructor. """
        self.action_editor = None
        self.issues = None
        self.provider = None
        self.locator_filter = None
        self.dock_action = None
        self.help_action = None
        plugin_dir = os.path.dirname(__file__)
        end_find = plugin_dir.rfind('\\') + 1
        global NAME
        NAME = plugin_dir[end_find:]
        maj_verif(NAME)

        # Display About window on first use
        version = qgis.utils.pluginMetadata('CenRa_COPIE', 'version')
        s = QSettings()
        versionUse = s.value("copie/version", 1, type=str)
        if str(versionUse) != str(version):
            s.setValue("copie/version", str(version))
            print(versionUse, version)
            self.open_about_dialog()

    def initGui(self):
        """ Build the plugin GUI. """

        self.toolBar = iface.addToolBar("CenRa_Copie")
        self.toolBar.setObjectName("CenRa_Copie")

        icon = QIcon(resources_path('icons', 'icon.png'))

        # Open the online help
        self.help_action = QAction(icon, "CenRa_Copie", iface.mainWindow())
        iface.pluginHelpMenu().addAction(self.help_action)
        self.help_action.triggered.connect(self.open_help)
        if not self.action_editor:
            self.action_editor = Copie_Editor()

            self.copie_editor = QAction(icon, 'Copie', None)
            self.toolBar.addAction(self.copie_editor)
            self.copie_editor.triggered.connect(self.open_editor)
            self.copie_editor.setEnabled(False)
            # IPAddr = socket.gethostbyname(socket.gethostname())
            if os.access('N:/', os.R_OK):
                self.copie_editor.setEnabled(True)

    def open_about_dialog(self):
        """
        About dialog
        """
        dialog = AboutDialog(iface)
        dialog.exec()

    def open_help():
        """ Open the online help. """
        QDesktopServices.openUrl(QUrl('https://plateformesig.cenra-outils.org/'))

    def open_editor(self):
        self.action_editor.show()
        self.action_editor.raise_()

    def unload(self):
        """ Unload the plugin. """
        if self.action_editor:
            iface.removePluginMenu('CenRa_Copie', self.copie_editor)

        if self.provider:
            QgsApplication.processingRegistry().removeProvider(self.provider)
            del self.provider

        if self.locator_filter:
            iface.deregisterLocatorFilter(self.locator_filter)
            del self.locator_filter

        if self.help_action:
            iface.pluginHelpMenu().removeAction(self.help_action)
            del self.help_action
